# -*- Mode: Python; tab-width: 4 -*-

rules = """
specification ::
## definition +
@R rule_1_a		:: specification >> specification definition
@R rule_1_b		:: specification >> definition
##
@R rule_2		:: definition >> type_dcl ;
@R rule_2_a		:: definition >> const_dcl ;
@R rule_2_b		:: definition >> except_dcl ;
@R rule_2_c		:: definition >> interface_spec ;
@R rule_2_d		:: definition >> module_spec ;
##
@R rule_3		:: module_spec >> module identifier { specification }
##
@R rule_4		:: interface_spec >> interface_dcl
@R rule_4_a		:: interface_spec >> forward_dcl
##
@R rule_5		:: interface_dcl >> interface_header { interface_body }
##
@R rule_6		:: forward_dcl >> interface identifier
##
@R rule_7		:: interface_header >> interface identifier inheritance_spec_opt
@R rule_7_a		:: inheritance_spec_opt >> inheritance_spec
@R rule_7_b		:: inheritance_spec_opt >>
##
@R rule_8_a		:: interface_body >>
@R rule_8_b		:: interface_body >> interface_body export 
##
@R rule_9		:: export >> type_dcl ;
@R rule_9_a		:: export >> const_dcl ;
@R rule_9_b		:: export >> except_dcl ;
@R rule_9_c		:: export >> attr_dcl ;
@R rule_9_d		:: export >> op_dcl ;
##
@R rule_10		:: inheritance_spec >> : scoped_name_list
@R rule_10_a	:: scoped_name_list >> scoped_name_list , scoped_name
@R rule_10_b	:: scoped_name_list >> scoped_name
##
@R rule_11		:: scoped_name >> identifier
@R rule_11_a	:: scoped_name >> DOUBLE_COLON identifier
@R rule_11_b	:: scoped_name >> scoped_name DOUBLE_COLON identifier
##
@R rule_12		:: const_dcl >> const const_type identifier = const_exp
##
@R rule_13		:: const_type >> integer_type
@R rule_13_a	:: const_type >> char_type
@R rule_13_b	:: const_type >> boolean_type
@R rule_13_c	:: const_type >> floating_pt_type
@R rule_13_d	:: const_type >> string_type
@R rule_13_e	:: const_type >> scoped_name
##
@R rule_14		:: const_exp >> or_expr
##
@R rule_15		:: or_expr >> xor_expr
@R rule_15_a	:: or_expr >> or_expr | xor_expr
##
@R rule_16		:: xor_expr >> and_expr
@R rule_16_a	:: xor_expr >> xor_expr ^ and_expr
##
@R rule_17		:: and_expr >> shift_expr
@R rule_17_a	:: and_expr >> and_expr & shift_expr
##
@R rule_18		:: shift_expr >> add_expr
@R rule_18_a	:: shift_expr >> shift_expr DOUBLE_GREATER_THAN add_expr
@R rule_18_b	:: shift_expr >> shift_expr << add_expr
##
@R rule_19		:: add_expr >> mult_expr
@R rule_19_a	:: add_expr >> add_expr + mult_expr
@R rule_19_b	:: add_expr >> add_expr - mult_expr
##
@R rule_20		:: mult_expr >> unary_expr
@R rule_20_a	:: mult_expr >> mult_expr * unary_expr
@R rule_20_b	:: mult_expr >> mult_expr / unary_expr
@R rule_20_c	:: mult_expr >> mult_expr % unary_expr
##
@R rule_21		:: unary_expr >> unary_operator primary_expr
@R rule_21_a	:: unary_expr >> primary_expr
##
@R rule_22		:: unary_operator >> -
@R rule_22_a	:: unary_operator >> +
@R rule_22_b	:: unary_operator >> ~
##
@R rule_23		:: primary_expr >> scoped_name
@R rule_23_a	:: primary_expr >> literal
@R rule_23_b	:: primary_expr >> ( const_exp )
##
@R rule_24		:: literal >> integer_literal
@R rule_24_a	:: literal >> string_literal
@R rule_24_b	:: literal >> character_literal
@R rule_24_c	:: literal >> floating_pt_literal
@R rule_24_d	:: literal >> boolean_literal
##
@R rule_25		:: boolean_literal >> TRUE
@R rule_25_a	:: boolean_literal >> FALSE
##
@R rule_26		:: positive_int_const >> const_exp
##
@R rule_27		:: type_dcl >> typedef type_declarator
@R rule_27_a	:: type_dcl >> struct_type
@R rule_27_b	:: type_dcl >> union_type
@R rule_27_c	:: type_dcl >> enum_type
##
@R rule_28		:: type_declarator >> type_spec declarators
##
@R rule_29		:: type_spec >> simple_type_spec
@R rule_29_a	:: type_spec >> constr_type_spec
##
@R rule_30		:: simple_type_spec >> base_type_spec
@R rule_30_a	:: simple_type_spec >> template_type_spec
@R rule_30_b	:: simple_type_spec >> scoped_name
##
@R rule_31		:: base_type_spec >> floating_pt_type
@R rule_31_a	:: base_type_spec >> integer_type
@R rule_31_b	:: base_type_spec >> char_type
@R rule_31_c	:: base_type_spec >> boolean_type
@R rule_31_d	:: base_type_spec >> octet_type
@R rule_31_d	:: base_type_spec >> any_type
##
@R rule_32		:: template_type_spec >> sequence_type
@R rule_32_a	:: template_type_spec >> string_type
##
@R rule_33		:: constr_type_spec >> struct_type
@R rule_33_a	:: constr_type_spec >> union_type
@R rule_33_b	:: constr_type_spec >> enum_type
##
@R rule_34_a	:: declarators >> declarator
@R rule_34_b	:: declarators >> declarators , declarator
##
@R rule_35		:: declarator >> simple_declarator
@R rule_35_a	:: declarator >> complex_declarator
##
@R rule_36		:: simple_declarator >> identifier
##
@R rule_37		:: complex_declarator >> array_declarator
##
@R rule_38		:: floating_pt_type >> float
@R rule_38_a	:: floating_pt_type >> double
##
@R rule_39		:: integer_type >> signed_int
@R rule_39_a	:: integer_type >> unsigned_int
##
@R rule_40		:: signed_int >> signed_long_int
@R rule_40_a	:: signed_int >> signed_short_int
##
@R rule_41		:: signed_long_int >> long
##
@R rule_42		:: signed_short_int >> short
##
@R rule_43		:: unsigned_int >> unsigned_long_int
@R rule_43_a	:: unsigned_int >> unsigned_short_int
##
@R rule_44		:: unsigned_long_int >> unsigned long
##
@R rule_45		:: unsigned_short_int >> unsigned short
##
@R rule_46		:: char_type >> char
##
@R rule_47		:: boolean_type >> boolean
##
@R rule_48		:: octet_type >> octet
##
@R rule_49		:: any_type >> any
##
@R rule_50		:: struct_type >> struct identifier { member_list }
##
@R rule_51		:: member_list >> member
@R rule_51_a	:: member_list >> member_list member
##
@R rule_52		:: member >> type_spec declarators ;
##
@R rule_53		:: union_type >> union identifier switch ( switch_type_spec ) { switch_body }
##
@R rule_54		:: switch_type_spec >> integer_type
@R rule_54_a	:: switch_type_spec >> char_type
@R rule_54_b	:: switch_type_spec >> boolean_type
@R rule_54_c	:: switch_type_spec >> enum_type
@R rule_54_d	:: switch_type_spec >> scoped_name
##
@R rule_55_a	:: switch_body >> case
@R rule_55_b	:: switch_body >> switch_body case
##
@R rule_56		:: case >> case_label_plus element_spec ;
@R rule_56_a	:: case_label_plus >> case_label
@R rule_56_b	:: case_label_plus >> case_label_plus case_label
##
@R rule_57		:: case_label >> case const_exp :
@R rule_57_a	:: case_label >> default :
##
@R rule_58		:: element_spec >> type_spec declarator
##
@R rule_59_a	:: enum_type >> enum identifier { enumerator_list }
@R rule_59_b	:: enumerator_list >> enumerator
@R rule_59_c	:: enumerator_list >> enumerator_list , enumerator
##
@R rule_60		:: enumerator >> identifier
##
@R rule_61		:: sequence_type >> sequence < simple_type_spec , positive_int_const >
@R rule_61_a	:: sequence_type >> sequence < simple_type_spec >
##
@R rule_62		:: string_type >> string < positive_int_const >
@R rule_62_a	:: string_type >> string
##
@R rule_63_a	:: array_declarator >> identifier fixed_array_size_list
@R rule_63_b	:: fixed_array_size_list >> fixed_array_size
@R rule_63_c	:: fixed_array_size_list >> fixed_array_size_list fixed_array_size
##
@R rule_64		:: fixed_array_size >> [ positive_int_const ]
##
@R rule_65		:: attr_dcl >> readonly_opt attribute param_type_spec simple_declarator_list
@R rule_65_a	:: simple_declarator_list >> simple_declarator
@R rule_65_b	:: simple_declarator_list >> simple_declarator_list , simple_declarator
@R rule_65_c	:: readonly_opt >> readonly
@R rule_65_d	:: readonly_opt >>
##
@R rule_66		:: except_dcl >> exception identifier { member_star }
@R rule_66_a	:: member_star >> member_star member
@R rule_66_b	:: member_star >>
##
@R rule_67		:: op_dcl >> op_attribute_opt op_type_spec identifier parameter_dcls raises_expr_opt context_expr_opt
@R rule_67_a	:: op_attribute_opt >> op_attribute
@R rule_67_b	:: op_attribute_opt >>
@R rule_67_c	:: raises_expr_opt >> raises_expr
@R rule_67_d	:: raises_expr_opt >>
@R rule_67_e	:: context_expr_opt >> context_expr
@R rule_67_f	:: context_expr_opt >>
##
@R rule_68		:: op_attribute >> oneway
##
@R rule_69		:: op_type_spec >> param_type_spec
@R rule_69_a	:: op_type_spec >> void
##
@R rule_70		:: parameter_dcls >> ( param_dcl_list )
@R rule_70_a	:: parameter_dcls >> ( )
@R rule_70_b	:: param_dcl_list >> param_dcl
@R rule_70_c	:: param_dcl_list >> param_dcl_list , param_dcl
##
@R rule_71		:: param_dcl >> param_attribute param_type_spec simple_declarator
##
@R rule_72		:: param_attribute >> in
@R rule_72_a	:: param_attribute >> out
@R rule_72_b	:: param_attribute >> inout
##
@R rule_73		:: raises_expr >> raises ( scoped_name_list )
##
@R rule_74		:: context_expr >> context ( string_literal_list )
@R rule_74_a	:: string_literal_list >> string_literal
@R rule_74_a	:: string_literal_list >> string_literal_list , string_literal
##
@R rule_75		:: param_type_spec >> base_type_spec
@R rule_75_a	:: param_type_spec >> string_type
@R rule_75_b	:: param_type_spec >> scoped_name
"""

non_terms = """specification definition module_spec interface_spec
interface_dcl forward_dcl interface_header interface_body export
inheritance_spec scoped_name_list scoped_name const_dcl const_type
const_exp or_expr xor_expr and_expr shift_expr add_expr mult_expr
unary_expr unary_operator primary_expr literal boolean_literal
positive_int_const type_dcl type_declarator type_spec simple_type_spec
base_type_spec template_type_spec constr_type_spec declarators
declarator simple_declarator complex_declarator floating_pt_type
integer_type signed_int signed_long_int signed_short_int unsigned_int
unsigned_long_int unsigned_short_int char_type boolean_type octet_type
any_type struct_type member_list member union_type switch_type_spec
switch_body case case_label_plus case_label element_spec enum_type
enumerator_list enumerator sequence_type string_type array_declarator
fixed_array_size_list fixed_array_size attr_dcl simple_declarator_list
except_dcl member_star op_dcl op_attribute op_type_spec parameter_dcls
param_dcl_list param_dcl param_attribute raises_expr context_expr
string_literal_list param_type_spec inheritance_spec_opt readonly_opt
op_attribute_opt raises_expr_opt context_expr_opt"""

# not complete, just testing...
integer_regex	= "[0-9]+"
float_regex		= "[0-9]+\.[0-9]+"
ident_regex		= "[A-Za-z0-9_]+"
string_regex	= '".*"'
character_regex	= "'[^']+'"
boolean_regex	= '\(true\)\|\(false\)'

# comments
comments = ['/\*.*\*/', '//.*$']

keywords = """any default inout out switch attribute double interface
raises TRUE boolean enum long readonly typedef case exception module
sequence unsigned char FALSE Object short union const float octet
string void context in oneway struct <<"""

punctuation = ':;{},=+-()<>[]\'"\\|^&*/%~'

def echo (s):
	return s

import kjParseBuild

def add_terminals (g):
	# literals
	g.Addterm ("integer_literal", integer_regex, echo)
	g.Addterm ("string_literal", string_regex, echo)
	g.Addterm ("character_literal", character_regex, echo)
	g.Addterm ("floating_pt_literal", float_regex, echo)
	g.Addterm ("boolean_literal", boolean_regex, echo)
	g.Addterm ("identifier", ident_regex, echo)
	# meta-grammar symbols
	g.Addterm ("DOUBLE_COLON", "::", echo)
	g.Addterm ("DOUBLE_GREATER_THAN", ">>", echo)	

def build ():
	g = kjParseBuild.NullCGrammar()
	# keywords
	g.Keywords (keywords)
	# terminals
	add_terminals (g)
	# punctuation
	g.punct (punctuation)
	# non-terminals
	g.Nonterms (non_terms)
	# comments
	g.comments (comments)
	# rules
	g.Declarerules (rules)
	g.Compile()
	fd = open ('idl_grammar.mar', 'wb')
	print 'dumping...'
	g.MarshalDump (fd)
	fd.close()
	return g

# I got mine from the ILU distribution:  stubbers/idl2isl/Sun-parser/idl_specs

sun_samples = [
	'array.idl',
	'constant.idl',
	'dif2.idl',
	'inherit.idl',
	'module.idl',
	'primtypes.idl',
	'sequence.idl',
	'simple.idl',
# uses #include
#	'simple2.idl',
	'struct.idl',
	'union.idl',
	'union2.idl',
	]

def test():
	g = build()
	result = []
	for f in sun_samples:
		s = open ('./idl_specs/%s' % f).read()
		result.append (g.DoParse (s))
		print '%s: %s' % (f, repr(result))
	return result

if __name__ == '__main__':
	build()
